import ev3dev2.motor
from ev3dev2.sensor import INPUT_1, INPUT_2, INPUT_3, INPUT_4
import ev3dev2.sensor.lego
from ev3dev2.sensor.lego import UltrasonicSensor
import time

from time import sleep

from ev3dev2.motor import LargeMotor, OUTPUT_A, OUTPUT_B, SpeedPercent, MoveTank
from ev3dev2.sensor import INPUT_1
from ev3dev2.sensor.lego import ColorSensor
from ev3dev2.led import Leds

class Ev3Wrapper:

    def __init__(self):
        self.tank_drive = MoveTank(OUTPUT_A, OUTPUT_B)


    def avanzar(self, val):
        self.tank_drive.on(SpeedPercent(val*10), SpeedPercent(val*10))

    def retroceder(self, val):
        self.tank_drive.on(SpeedPercent(-val*10), SpeedPercent(-val*10))

    def girar_derecha(self, w):

        self.tank_drive.on(SpeedPercent(w*100), SpeedPercent(0))

    def girar_izquierda(self, w):

        self.tank_drive.on(SpeedPercent(0), SpeedPercent(w*100))

    def avanzar_hasta(self, distance):
        # the number of degrees each wheel needs to turn
        seconds = distance/0.25
        self.tank_drive.on_for_seconds(SpeedPercent(50),SpeedPercent(50),seconds=seconds,brake=True,block=True)

    def retroceder_hasta(self, distance):
        seconds = distance / 0.25
        self.tank_drive.on_for_seconds(SpeedPercent(-50), SpeedPercent(-50), seconds=seconds, brake=True, block=True)

    def girar_derecha_hasta(self, degrees):
        self.tank_drive.on_for_degrees(100, 0, degrees=degrees*4, brake=True, block=True)

    def girar_izquierda_hasta(self, degrees):
        self.tank_drive.on_for_degrees(0, 100, degrees=degrees*4, brake=True, block=True)

    def parar(self):
        self.tank_drive.on(0, 0)

